% Markov Process 

clear
N = 5;                              % number of states (N is odd)
p = 0.3;                            % up-step probability
q = 1-p;                            % down-step probability
max_n = 10;                         % maximum number of steps
P = [ 0   .2   .1  .5  .2
    [ .1   0   .8  .1   0]
    [ .6  .1    0  .1  .2]
    [ .1   0   .9   0   0]
    [ .3   0   .2   .5  0]];


e_0 = zeros(N,1);                   % initialize initial-state vector
e_0(round((N+1)/2)) = 1;            % set initial-state vector
s = zeros(1,max_n);            % initialize state matrix
states = zeros(N,max_n);            % initialize state matrix
% --- Loop through process -------
s(1) = 1;
for n=1:max_n
    randomNum = rand(1);
    if
        P()
end
% --- Loop through probabilities -------
for n=2:max_n
    pn = P^n;
    e_n = pn*e_0;
    states(:,n) = e_n;
end
figure(1)
    imagesc (states);
    colorbar;
    
finalProb = (states(:,max_n) + states(:,max_n-1));
figure(2)
    plot (finalProb);
    title('Final state probability')       
    xlabel('state')
    ylabel('probability')
    ylim([0 0.5])
